Index: trunk/src/lib/graphics/graphics_engine.cc
===================================================================
--- trunk/src/lib/graphics/graphics_engine.cc	(revision 6775)
+++ trunk/src/lib/graphics/graphics_engine.cc	(revision 6778)
@@ -321,6 +321,4 @@
       //    return -1;
     }
-    glMatrixMode(GL_PROJECTION_MATRIX);
-    glLoadIdentity();
     glViewport(0, 0, width, height);                     // Reset The Current Viewport
 
@@ -451,10 +449,7 @@
   glDisable(GL_LIGHTING);  // will be set back when leaving 2D-mode
 
-  glViewport(0, 0, screen->w, screen->h);
-
   glMatrixMode(GL_PROJECTION);
   glPushMatrix();
   glLoadIdentity();
-
   glOrtho(0.0, (GLdouble)screen->w, (GLdouble)screen->h, 0.0, 0.0, 1.0);
 
@@ -462,6 +457,4 @@
   glPushMatrix();
   glLoadIdentity();
-
-  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
 }
 
@@ -585,6 +578,8 @@
 void GraphicsEngine::draw() const
 {
+  GraphicsEngine::storeMatrices();
+
   LightManager::getInstance()->draw();
-  GraphicsEngine::storeMatrices();
+
   Shader::suspendShader();
 
Index: trunk/src/lib/graphics/light.cc
===================================================================
--- trunk/src/lib/graphics/light.cc	(revision 6775)
+++ trunk/src/lib/graphics/light.cc	(revision 6778)
@@ -342,7 +342,5 @@
 void LightManager::draw() const
 {
-  glMatrixMode(GL_MODELVIEW);
-  glLoadIdentity();
-  PRINTF(4)("Drawing the Lights\n");
+ PRINTF(4)("Drawing the Lights\n");
   for (int i = 0; i < NUMBEROFLIGHTS; i++)
     if (this->lights[i])
Index: trunk/src/lib/graphics/render2D/element_2d.cc
===================================================================
--- trunk/src/lib/graphics/render2D/element_2d.cc	(revision 6775)
+++ trunk/src/lib/graphics/render2D/element_2d.cc	(revision 6778)
@@ -820,5 +820,5 @@
     else if (unlikely(this->bindNode != NULL))
     {
-      GLdouble projectPos[3] = {0, 0, 0};
+      GLdouble projectPos[3] = {0.0, 0.0, 0.0};
       gluProject(this->bindNode->getAbsCoor().x,
                  this->bindNode->getAbsCoor().y,
@@ -830,4 +830,11 @@
                  projectPos+1,
                  projectPos+2);
+//       printf("%s::%s  == %f %f %f :: %f %f\n", this->getClassName(), this->getName(),
+//              this->bindNode->getAbsCoor().x,
+//              this->bindNode->getAbsCoor().y,
+//              this->bindNode->getAbsCoor().z,
+//              projectPos[0],
+//              projectPos[1]);
+
       this->prevRelCoordinate.x = this->absCoordinate.x = projectPos[0] /* /(float)GraphicsEngine::getInstance()->getResolutionX() */ + this->relCoordinate.x;
       this->prevRelCoordinate.y = this->absCoordinate.y = (float)GraphicsEngine::getInstance()->getResolutionY() -  projectPos[1] + this->relCoordinate.y;
Index: trunk/src/world_entities/camera.cc
===================================================================
--- trunk/src/world_entities/camera.cc	(revision 6775)
+++ trunk/src/world_entities/camera.cc	(revision 6778)
@@ -188,9 +188,11 @@
   glLoadIdentity ();
 
-  // setting up the perspective
   gluPerspective(this->fovy,
                  this->aspectRatio,
                  this->nearClip,
                  this->farClip);
+
+
+    // setting up the perspective
   // speed-up feature
   Vector cameraPosition = this->getAbsCoor();
@@ -205,6 +207,10 @@
             up.x, up.y, up.z);
 
+
   glMatrixMode (GL_MODELVIEW);
   glLoadIdentity();
+
+
+
 }
 
Index: trunk/src/world_entities/skysphere.cc
===================================================================
--- trunk/src/world_entities/skysphere.cc	(revision 6775)
+++ trunk/src/world_entities/skysphere.cc	(revision 6778)
@@ -97,6 +97,7 @@
 void Skysphere::draw() const
 {
+  glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
-  glMatrixMode(GL_MODELVIEW);
+
   Vector r = this->getAbsCoor();
   glTranslatef(r.x, r.y, r.z);
Index: trunk/src/world_entities/weapons/test_gun.cc
===================================================================
--- trunk/src/world_entities/weapons/test_gun.cc	(revision 6775)
+++ trunk/src/world_entities/weapons/test_gun.cc	(revision 6778)
@@ -219,5 +219,4 @@
 
   /* draw objectComponent1: gun coil - animated stuff */
-  glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
   glTranslatef (this->objectComponent1->getAbsCoor ().x,
Index: trunk/src/world_entities/weapons/weapon_manager.cc
===================================================================
--- trunk/src/world_entities/weapons/weapon_manager.cc	(revision 6775)
+++ trunk/src/world_entities/weapons/weapon_manager.cc	(revision 6778)
@@ -417,5 +417,4 @@
         this->currentSlotConfig[i].position.activateNode();
         tickWeapon->setParent(&this->currentSlotConfig[i].position);
-        printf("ACTIVATE\n");
       }
       else
